Skip to main content

Overview

Seam provides a universal API to connect and control many brands of smart devices. This guide provides a rapid introduction to connecting and controlling your ControlByWeb relay device using the Seam API. To learn more about other smart device brands supported by Seam such as Yale, Schlage, and August, head over to our integration page.

1 — Install Seam SDK

Seam provides client libraries for many languages, such as JavaScript, Python, Ruby, PHP, and others, as well as a Postman collection and OpenAPI spec.
npm i seam
Once installed, sign-up for Seam to get your API key, and export it as an environment variable:
$ export SEAM_API_KEY=seam_test2ZTo_0mEYQW2TvNDCxG5Atpj85Ffw
This guide uses a Sandbox Workspace. Only virtual devices can be connected. If you need to connect a real ControlByWeb device, use a non-sandbox workspace and API key.
To control your ControlByWeb relay device via the Seam API, you must first authorize your Seam workspace against your ControlByWeb Cloud account. To do so, Seam provides Connect Webviews: pre-built UX flows that walk you through authorizing your application to control your ControlByWeb device.

Request a Connect Webview

import { Seam } from 'seam'

const seam = new Seam()

const connectWebview = await seam.connectWebviews.create({
  accepted_providers: ['controlbyweb'],
})

console.log(connectWebview.login_successful) // false

// Send the webview URL to your user
console.log(connectWebview.url)

Authorize Your Workspace

Navigate to the URL returned by the Webview object. Since you are using a sandbox workspace, complete the login flow by entering the ControlByWeb sandbox test account credentials below:
  • username: jane
  • password: 1234
Confirm the Connect Webview was successful by querying its status:
const updatedWebview = await seam.connectWebviews.get(
  connectWebview.connect_webview_id,
)

console.log(updatedWebview.login_successful) // true

3 — Retrieve ControlByWeb devices

After a ControlByWeb account is linked with Seam, you can retrieve devices for this ControlByWeb account. The main device property currently exposed by the Seam API is whether the device is online and reachable.
const allLocks = await seam.locks.list()

const someLock = allLocks[0]

console.log(someLock.properties.online) // true
console.log(someLock.properties.locked) // true

console.log(someLock)
/*
{
  device_id: '4a570d13-9704-46e0-b69c-9fea80d6a7aa',
  device_type: 'controlbyweb_device',
  capabilities_supported: [ 'lock' ],
  properties: {
    locked: true,
    online: true,
    manufacturer: 'controlbyweb',
    controlbyweb_metadata: {
      device_id: '9997',
      relay_name: 'firstRelay',
      device_name: 'Device 2'
    },
    name: 'Device 2',
    image_url: 'https://connect.getseam.com/assets/images/devices/unknown-lock.png',
    image_alt_text: 'Placeholder Lock Image'
  },
  location: null,
  connected_account_id: '5e0f49ac-3cb5-4e81-8c74-aba262218611',
  workspace_id: '40a179ca-3553-4226-9483-21df4e12f5fe',
  created_at: '2023-04-25T14:34:50.508Z',
  errors: [],
  warnings: []
}
*/
4 — Triggering a ControlByWeb relay Next, you can perform the basic action of triggering a relay on the device. This action is mapped to an unlock API call in Seam.

Unlock a door

POST https://connect.getseam.com/locks/unlock_door Request Body
NameTypeDescription
device_idString
// trigger the relay
await seam.locks.unlockDoor(someLock.device_id)

Next Steps

Now that you’ve completed this guide, you can try to connect a real ControlByWeb device. To do so, make sure to switch to a non-sandbox workspace and API key as real devices cannot be connected to sandbox workspaces. In addition, if you’d like to explore other aspects of Seam, here is a list of helpful resources: If you have any questions or want to report an issue, email us at support@seam.co.